/**
 * SKA MID Sensitivity Calculator API
 * The SKA MID Sensitivity Calculator API offers two modes: continuum and zoom.  Each of these has an API resource to calculate a sensitivity or integration time for an observation,  and another to retrieve information relating to image weighting (beam-size and relative sensitivity).  There is also a resource for obtaining subarray information. 
 *
 * The version of the OpenAPI document: 10.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent, HttpParameterCodec, HttpContext 
        }       from '@angular/common/http';
import { CustomHttpParameterCodec }                          from '../encoder';
import { Observable }                                        from 'rxjs';

// @ts-ignore
import { MidContinuumSensitivityResponse } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/continuumSensitivityResponse';
// @ts-ignore
import { MidContinuumWeightingResult } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/continuumWeightingResult';
// @ts-ignore
import { MidErrorModel } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/errorModel';
// @ts-ignore
import { MidSingleWeightingZoomResult } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/singleWeightingZoomResult';
// @ts-ignore
import { MidSingleZoomSensitivityResponse } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/singleZoomSensitivityResponse';
// @ts-ignore
import { MidSubarraysResponse } from '../ska_ost_senscalc_ui.app.generated.api.mid.model/subarraysResponse';

// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { MidConfiguration }                                     from '../configuration';


export interface SkaOstSenscalcMidApiContinuumCalculateRequestParams {
    /** Enumeration of the receiver bands available for MID. Band 5a and 5b are not available for subarrays that include 13.5-m antennas (n_meer &gt; 0). */
    rxBand: 'Band 1' | 'Band 2' | 'Band 3' | 'Band 4' | 'Band 5a' | 'Band 5b';
    /** Central frequency in Hz. Combined with the bandwidth_mhz, it must define a spectral window that is contained within the rx_band. */
    freqCentreHz: number;
    /** Bandwidth for the continuum observation in Hz. Combined with the freq_centre_hz, it must define a spectral window that is contained within the rx_band. */
    bandwidthHz: number;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** The integration time of the observation in seconds. Should only be specified when calculating sensitivity and sensitivity_jy parameter is not specified.  */
    integrationTimeS?: number;
    /** The sensitivity of the observation in Jy. Should only be specified when calculating integration time and integration_time_s parameter is not specified.  */
    sensitivityJy?: number;
    /** The enumerated option for the array configuration to use to perform the calculation. To define a custom configuration, set n_ska and n_meer and do not set this parameter. */
    subarrayConfiguration?: 'AA0.5' | 'AA1' | 'AA2' | 'AA*' | 'AA* (15-m antennas only)' | 'AA4' | 'AA*_/AA4 (13.5-m antennas only)' | 'AA4 (15-m antennas only)';
    /** Number of 15-m antennas in the custom subarray. If set, n_meer must also be set and subarray_configuration should not be set. */
    nSka?: number;
    /** Number of 13.5-m antennas in the custom subarray. If set, n_ska must also be set and subarray_configuration should not be set. */
    nMeer?: number;
    /** Factor by which the spectral resolution should be averaged to calculate the effective resolution which is used in the calculation. The allowed values correspond to those offered by the Mid correlator. */
    spectralAveragingFactor?: 1 | 2 | 3 | 4 | 6 | 8 | 12 | 24;
    /** Precipitable water vapour in mm. */
    pwv?: number;
    /** Elevation of the target that the observation will be performed at. */
    el?: number;
    /** If this parameter is provided, the \&#39;subbands\&#39; field in the response body will contain a sensitivity result  for each sub-band, which is calculated by dividing the bandwidth in N sub-bands. If the value is given as 1 then  this is equal to the main sensitivity calculation so no \&#39;subbands\&#39; are returned in the response. Note: if calculating integration time, subband_sensitivities_jy must also be set.  */
    nSubbands?: number;
    /** Ordered array of the (thermal) sensitivity (Jy) for each sub-band, used when calculating integration time.  (n_subbands must be set as well and have the same number of elements).  */
    subbandSensitivitiesJy?: Array<number>;
    /** System efficiency. If provided, will be used instead of calculating it from eta_pointing, eta_coherence, eta_digitisation, eta_bandpass and eta_correlation  */
    etaSystem?: number;
    /** Pointing efficiency */
    etaPointing?: number;
    /** Coherence efficiency */
    etaCoherence?: number;
    /** Digitisation efficiency */
    etaDigitisation?: number;
    /** Correlation efficiency */
    etaCorrelation?: number;
    /** Bandpass efficiency */
    etaBandpass?: number;
    /** System Temperature of the 15-m antennas (K) */
    tSysSka?: number;
    /** Receiver Temperature of the 15-m antennas (K) */
    tRxSka?: number;
    /** Spillover Temperature of the 15-m antennas (K) */
    tSplSka?: number;
    /** System Temperature of the 13.5-m antennas (K) */
    tSysMeer?: number;
    /** Receiver Temperature of the 13.5-m antennas (K) */
    tRxMeer?: number;
    /** Spillover Temperature of the 13.5-m antennas (K) */
    tSplMeer?: number;
    /** Sky temperature for 15-m antennas (K) */
    tSkySka?: number;
    /** Galactic temperature for 15-m antennas (K) */
    tGalSka?: number;
    /** Galactic temperature for 13.5-m antennas (K) */
    tGalMeer?: number;
    /** Spectral index of Galactic emission */
    alpha?: number;
    /** Dish efficiency for 13.5-m antennas */
    etaMeer?: number;
    /** Dish efficiency for 15-m antennas */
    etaSka?: number;
}

export interface SkaOstSenscalcMidApiContinuumWeightingRequestParams {
    /** Enumeration of the spectral mode to use to in the weighting look up table.  */
    spectralMode: 'continuum' | 'line';
    /** Central frequency in Hz. Combined with the bandwidth_mhz, it must define a spectral window that is contained within the rx_band. */
    freqCentreHz: number;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** Enumeration of the weighting strategy used. */
    weightingMode: 'natural' | 'robust' | 'uniform';
    /** Robust parameter. Only required and considered if the weighting is set to robust. */
    robustness?: -2 | -1 | 0 | 1 | 2;
    /** The enumerated option for the array configuration to use to perform the calculation. To define a custom configuration, set n_ska and n_meer and do not set this parameter. */
    subarrayConfiguration?: 'AA0.5' | 'AA1' | 'AA2' | 'AA*' | 'AA* (15-m antennas only)' | 'AA4' | 'AA*_/AA4 (13.5-m antennas only)' | 'AA4 (15-m antennas only)';
    /** Gaussian taper (specified as arcseconds in image plane). No taper applied if left empty. */
    taper?: 0 | 0.25 | 1 | 4 | 16 | 64 | 256 | 1024;
    /** Central frequency of each sub-band in Hz. Providing sub-band frequencies enables the provision of additional weighting outputs. */
    subbandFreqCentresHz?: Array<number>;
}

export interface SkaOstSenscalcMidApiZoomCalculateRequestParams {
    /** Enumeration of the receiver bands available for MID. Band 5a and 5b are not available for subarrays that include 13.5-m antennas (n_meer &gt; 0). */
    rxBand: 'Band 1' | 'Band 2' | 'Band 3' | 'Band 4' | 'Band 5a' | 'Band 5b';
    /** Array of central frequency of zoom windows in Hz. Combined with the total_bandwidths_hz, each must define a spectral window that is contained within the rx_band.  */
    freqCentresHz: Array<number>;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** The enumerated option for the array configuration to use to perform the calculation. To define a custom configuration, set n_ska and n_meer and do not set this parameter. */
    subarrayConfiguration?: 'AA*' | 'AA* (15-m antennas only)' | 'AA4' | 'AA*_/AA4 (13.5-m antennas only)' | 'AA4 (15-m antennas only)';
    /** Number of 15-m antennas in the custom subarray. If set, n_meer must also be set and subarray_configuration should not be set. */
    nSka?: number;
    /** Number of 13.5-m antennas in the custom subarray. If set, n_ska must also be set and subarray_configuration should not be set. */
    nMeer?: number;
    /** Precipitable water vapour in mm. */
    pwv?: number;
    /** Elevation of the target that the observation will be performed at. */
    el?: number;
    /** Factor by which the spectral resolution should be averaged to calculate the effective resolution which is used in the calculation. The allowed values correspond to those offered by the Mid correlator. */
    spectralAveragingFactor?: 1 | 2 | 3 | 4 | 6 | 8 | 12 | 24;
    /** Array of zoom spectral resolutions. freq_centres_hz must be set as well and have the same number of elements. Validation only checks that the entered spectral resolution lies within the range defined by the narrowest and widest zoom windows, not that the entered spectral resolution corresponds to an actual zoom window.  */
    spectralResolutionsHz?: Array<number>;
    /** Array of zoom total bandwidths for each zoom window. Combined with the freq_centre_hz, each must define a spectral window that is contained within the rx_band. Validation only checks that the entered bandwidth lies within the range defined by the narrowest and widest zoom windows, not that the entered bandwidth corresponds to an actual zoom window. */
    totalBandwidthsHz?: Array<number>;
    /** Array of zoom sensitivities. This provides additional outputs for line observations (spectral_resolutions_hz and freq_centres_hz must be set as well and have the same number of elements).  Should only be specified when calculating integration time and integration_time_s parameter is not specified.  */
    sensitivitiesJy?: Array<number>;
    /** The integration time of the observation in seconds. Should only be specified when calculating sensitivity and sensitivities_jy parameter is not specified.  */
    integrationTimeS?: number;
    /** System efficiency. If provided, will be used instead of calculating it from eta_pointing, eta_coherence, eta_digitisation, eta_bandpass and eta_correlation  */
    etaSystem?: number;
    /** Pointing efficiency */
    etaPointing?: number;
    /** Coherence efficiency */
    etaCoherence?: number;
    /** Digitisation efficiency */
    etaDigitisation?: number;
    /** Correlation efficiency */
    etaCorrelation?: number;
    /** Bandpass efficiency */
    etaBandpass?: number;
    /** System Temperature of the 15-m antennas (K) */
    tSysSka?: number;
    /** Receiver Temperature of the 15-m antennas (K) */
    tRxSka?: number;
    /** Spillover Temperature of the 15-m antennas (K) */
    tSplSka?: number;
    /** System Temperature of the 13.5-m antennas (K) */
    tSysMeer?: number;
    /** Receiver Temperature of the 13.5-m antennas (K) */
    tRxMeer?: number;
    /** Spillover Temperature of the 13.5-m antennas (K) */
    tSplMeer?: number;
    /** Sky temperature for 15-m antennas (K) */
    tSkySka?: number;
    /** Galactic temperature for 15-m antennas (K) */
    tGalSka?: number;
    /** Galactic temperature for 13.5-m antennas (K) */
    tGalMeer?: number;
    /** Spectral index of Galactic emission */
    alpha?: number;
    /** Dish efficiency for 13.5-m antennas */
    etaMeer?: number;
    /** Dish efficiency for 15-m antennas */
    etaSka?: number;
}

export interface SkaOstSenscalcMidApiZoomWeightingRequestParams {
    /** Array of central frequency of zoom windows in Hz. Combined with the total_bandwidths_hz, each must define a spectral window that is contained within the rx_band.  */
    freqCentresHz: Array<number>;
    /** Pointing centre in HH:MM:SS[.ss] [+|-]DD:MM:SS[.ss] */
    pointingCentre: string;
    /** Enumeration of the weighting strategy used. */
    weightingMode: 'natural' | 'robust' | 'uniform';
    /** Robust parameter. Only required and considered if the weighting is set to robust. */
    robustness?: -2 | -1 | 0 | 1 | 2;
    /** The enumerated option for the array configuration to use to perform the calculation. To define a custom configuration, set n_ska and n_meer and do not set this parameter. */
    subarrayConfiguration?: 'AA*' | 'AA* (15-m antennas only)' | 'AA4' | 'AA*_/AA4 (13.5-m antennas only)' | 'AA4 (15-m antennas only)';
    /** Gaussian taper (specified as arcseconds in image plane). No taper applied if left empty. */
    taper?: 0 | 0.25 | 1 | 4 | 16 | 64 | 256 | 1024;
}


@Injectable({
  providedIn: 'root'
})
export class DefaultService {

    protected basePath = 'http://localhost';
    public defaultHeaders = new HttpHeaders();
    public configuration = new MidConfiguration();
    public encoder: HttpParameterCodec;

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string|string[], @Optional() configuration: MidConfiguration) {
        if (configuration) {
            this.configuration = configuration;
        }
        if (typeof this.configuration.basePath !== 'string') {
            if (Array.isArray(basePath) && basePath.length > 0) {
                basePath = basePath[0];
            }

            if (typeof basePath !== 'string') {
                basePath = this.basePath;
            }
            this.configuration.basePath = basePath;
        }
        this.encoder = this.configuration.encoder || new CustomHttpParameterCodec();
    }


    // @ts-ignore
    private addToHttpParams(httpParams: HttpParams, value: any, key?: string): HttpParams {
        if (typeof value === "object" && value instanceof Date === false) {
            httpParams = this.addToHttpParamsRecursive(httpParams, value);
        } else {
            httpParams = this.addToHttpParamsRecursive(httpParams, value, key);
        }
        return httpParams;
    }

    private addToHttpParamsRecursive(httpParams: HttpParams, value?: any, key?: string): HttpParams {
        if (value == null) {
            return httpParams;
        }

        if (typeof value === "object") {
            if (Array.isArray(value)) {
                (value as any[]).forEach( elem => httpParams = this.addToHttpParamsRecursive(httpParams, elem, key));
            } else if (value instanceof Date) {
                if (key != null) {
                    httpParams = httpParams.append(key, (value as Date).toISOString().substring(0, 10));
                } else {
                   throw Error("key may not be null if value is Date");
                }
            } else {
                Object.keys(value).forEach( k => httpParams = this.addToHttpParamsRecursive(
                    httpParams, value[k], key != null ? `${key}.${k}` : k));
            }
        } else if (key != null) {
            httpParams = httpParams.append(key, value);
        } else {
            throw Error("key may not be null if value is not object or array");
        }
        return httpParams;
    }

    /**
     * Calculates an integration time in seconds given a target sensitivity (or vice-versa) for the continuum mode.  The result contains a continuum calculation for the full window and a spectral line calculation. These should then each be combined with a response from the weighting endpoint for the respective spectral mode. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcMidApiContinuumCalculate(requestParameters: SkaOstSenscalcMidApiContinuumCalculateRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<MidContinuumSensitivityResponse>;
    public skaOstSenscalcMidApiContinuumCalculate(requestParameters: SkaOstSenscalcMidApiContinuumCalculateRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<MidContinuumSensitivityResponse>>;
    public skaOstSenscalcMidApiContinuumCalculate(requestParameters: SkaOstSenscalcMidApiContinuumCalculateRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<MidContinuumSensitivityResponse>>;
    public skaOstSenscalcMidApiContinuumCalculate(requestParameters: SkaOstSenscalcMidApiContinuumCalculateRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const rxBand = requestParameters.rxBand;
        if (rxBand === null || rxBand === undefined) {
            throw new Error('Required parameter rxBand was null or undefined when calling skaOstSenscalcMidApiContinuumCalculate.');
        }
        const freqCentreHz = requestParameters.freqCentreHz;
        if (freqCentreHz === null || freqCentreHz === undefined) {
            throw new Error('Required parameter freqCentreHz was null or undefined when calling skaOstSenscalcMidApiContinuumCalculate.');
        }
        const bandwidthHz = requestParameters.bandwidthHz;
        if (bandwidthHz === null || bandwidthHz === undefined) {
            throw new Error('Required parameter bandwidthHz was null or undefined when calling skaOstSenscalcMidApiContinuumCalculate.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcMidApiContinuumCalculate.');
        }
        const integrationTimeS = requestParameters.integrationTimeS;
        const sensitivityJy = requestParameters.sensitivityJy;
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const nSka = requestParameters.nSka;
        const nMeer = requestParameters.nMeer;
        const spectralAveragingFactor = requestParameters.spectralAveragingFactor;
        const pwv = requestParameters.pwv;
        const el = requestParameters.el;
        const nSubbands = requestParameters.nSubbands;
        const subbandSensitivitiesJy = requestParameters.subbandSensitivitiesJy;
        const etaSystem = requestParameters.etaSystem;
        const etaPointing = requestParameters.etaPointing;
        const etaCoherence = requestParameters.etaCoherence;
        const etaDigitisation = requestParameters.etaDigitisation;
        const etaCorrelation = requestParameters.etaCorrelation;
        const etaBandpass = requestParameters.etaBandpass;
        const tSysSka = requestParameters.tSysSka;
        const tRxSka = requestParameters.tRxSka;
        const tSplSka = requestParameters.tSplSka;
        const tSysMeer = requestParameters.tSysMeer;
        const tRxMeer = requestParameters.tRxMeer;
        const tSplMeer = requestParameters.tSplMeer;
        const tSkySka = requestParameters.tSkySka;
        const tGalSka = requestParameters.tGalSka;
        const tGalMeer = requestParameters.tGalMeer;
        const alpha = requestParameters.alpha;
        const etaMeer = requestParameters.etaMeer;
        const etaSka = requestParameters.etaSka;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (integrationTimeS !== undefined && integrationTimeS !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>integrationTimeS, 'integration_time_s');
        }
        if (sensitivityJy !== undefined && sensitivityJy !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>sensitivityJy, 'sensitivity_jy');
        }
        if (rxBand !== undefined && rxBand !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>rxBand, 'rx_band');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (nSka !== undefined && nSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nSka, 'n_ska');
        }
        if (nMeer !== undefined && nMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nMeer, 'n_meer');
        }
        if (freqCentreHz !== undefined && freqCentreHz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>freqCentreHz, 'freq_centre_hz');
        }
        if (bandwidthHz !== undefined && bandwidthHz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>bandwidthHz, 'bandwidth_hz');
        }
        if (spectralAveragingFactor !== undefined && spectralAveragingFactor !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralAveragingFactor, 'spectral_averaging_factor');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (pwv !== undefined && pwv !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pwv, 'pwv');
        }
        if (el !== undefined && el !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>el, 'el');
        }
        if (nSubbands !== undefined && nSubbands !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nSubbands, 'n_subbands');
        }
        if (subbandSensitivitiesJy) {
            subbandSensitivitiesJy.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'subband_sensitivities_jy');
            })
        }
        if (etaSystem !== undefined && etaSystem !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaSystem, 'eta_system');
        }
        if (etaPointing !== undefined && etaPointing !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaPointing, 'eta_pointing');
        }
        if (etaCoherence !== undefined && etaCoherence !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaCoherence, 'eta_coherence');
        }
        if (etaDigitisation !== undefined && etaDigitisation !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaDigitisation, 'eta_digitisation');
        }
        if (etaCorrelation !== undefined && etaCorrelation !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaCorrelation, 'eta_correlation');
        }
        if (etaBandpass !== undefined && etaBandpass !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaBandpass, 'eta_bandpass');
        }
        if (tSysSka !== undefined && tSysSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSysSka, 't_sys_ska');
        }
        if (tRxSka !== undefined && tRxSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tRxSka, 't_rx_ska');
        }
        if (tSplSka !== undefined && tSplSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSplSka, 't_spl_ska');
        }
        if (tSysMeer !== undefined && tSysMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSysMeer, 't_sys_meer');
        }
        if (tRxMeer !== undefined && tRxMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tRxMeer, 't_rx_meer');
        }
        if (tSplMeer !== undefined && tSplMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSplMeer, 't_spl_meer');
        }
        if (tSkySka !== undefined && tSkySka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSkySka, 't_sky_ska');
        }
        if (tGalSka !== undefined && tGalSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tGalSka, 't_gal_ska');
        }
        if (tGalMeer !== undefined && tGalMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tGalMeer, 't_gal_meer');
        }
        if (alpha !== undefined && alpha !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>alpha, 'alpha');
        }
        if (etaMeer !== undefined && etaMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaMeer, 'eta_meer');
        }
        if (etaSka !== undefined && etaSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaSka, 'eta_ska');
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/continuum/calculate`;
        return this.httpClient.request<MidContinuumSensitivityResponse>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Retrieve the parameters related to weighting (e.g. beam-size and relative sensitivity). The spectral_mode parameter determines whether results are retrieved for a continuum or spectral (line) observation. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcMidApiContinuumWeighting(requestParameters: SkaOstSenscalcMidApiContinuumWeightingRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<MidContinuumWeightingResult>;
    public skaOstSenscalcMidApiContinuumWeighting(requestParameters: SkaOstSenscalcMidApiContinuumWeightingRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<MidContinuumWeightingResult>>;
    public skaOstSenscalcMidApiContinuumWeighting(requestParameters: SkaOstSenscalcMidApiContinuumWeightingRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<MidContinuumWeightingResult>>;
    public skaOstSenscalcMidApiContinuumWeighting(requestParameters: SkaOstSenscalcMidApiContinuumWeightingRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const spectralMode = requestParameters.spectralMode;
        if (spectralMode === null || spectralMode === undefined) {
            throw new Error('Required parameter spectralMode was null or undefined when calling skaOstSenscalcMidApiContinuumWeighting.');
        }
        const freqCentreHz = requestParameters.freqCentreHz;
        if (freqCentreHz === null || freqCentreHz === undefined) {
            throw new Error('Required parameter freqCentreHz was null or undefined when calling skaOstSenscalcMidApiContinuumWeighting.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcMidApiContinuumWeighting.');
        }
        const weightingMode = requestParameters.weightingMode;
        if (weightingMode === null || weightingMode === undefined) {
            throw new Error('Required parameter weightingMode was null or undefined when calling skaOstSenscalcMidApiContinuumWeighting.');
        }
        const robustness = requestParameters.robustness;
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const taper = requestParameters.taper;
        const subbandFreqCentresHz = requestParameters.subbandFreqCentresHz;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (spectralMode !== undefined && spectralMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralMode, 'spectral_mode');
        }
        if (freqCentreHz !== undefined && freqCentreHz !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>freqCentreHz, 'freq_centre_hz');
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (weightingMode !== undefined && weightingMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>weightingMode, 'weighting_mode');
        }
        if (robustness !== undefined && robustness !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>robustness, 'robustness');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (taper !== undefined && taper !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>taper, 'taper');
        }
        if (subbandFreqCentresHz) {
            subbandFreqCentresHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'subband_freq_centres_hz');
            })
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/continuum/weighting`;
        return this.httpClient.request<MidContinuumWeightingResult>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Returns the array configurations available
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcMidApiSubarrays(observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<MidSubarraysResponse>>;
    public skaOstSenscalcMidApiSubarrays(observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<MidSubarraysResponse>>>;
    public skaOstSenscalcMidApiSubarrays(observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<MidSubarraysResponse>>>;
    public skaOstSenscalcMidApiSubarrays(observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/subarrays`;
        return this.httpClient.request<Array<MidSubarraysResponse>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Calculates an integration time in seconds given a target sensitivity (or vice-versa) for the zoom mode.  The result contains a spectral line calculation for the given zoom window. This should then each be combined  with a response from the weighting endpoint. Zoom modes are only available for the AA*, AA4 and custom subarrays (defined by n_ska and n_meer). 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcMidApiZoomCalculate(requestParameters: SkaOstSenscalcMidApiZoomCalculateRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<MidSingleZoomSensitivityResponse>>;
    public skaOstSenscalcMidApiZoomCalculate(requestParameters: SkaOstSenscalcMidApiZoomCalculateRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<MidSingleZoomSensitivityResponse>>>;
    public skaOstSenscalcMidApiZoomCalculate(requestParameters: SkaOstSenscalcMidApiZoomCalculateRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<MidSingleZoomSensitivityResponse>>>;
    public skaOstSenscalcMidApiZoomCalculate(requestParameters: SkaOstSenscalcMidApiZoomCalculateRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const rxBand = requestParameters.rxBand;
        if (rxBand === null || rxBand === undefined) {
            throw new Error('Required parameter rxBand was null or undefined when calling skaOstSenscalcMidApiZoomCalculate.');
        }
        const freqCentresHz = requestParameters.freqCentresHz;
        if (freqCentresHz === null || freqCentresHz === undefined) {
            throw new Error('Required parameter freqCentresHz was null or undefined when calling skaOstSenscalcMidApiZoomCalculate.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcMidApiZoomCalculate.');
        }
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const nSka = requestParameters.nSka;
        const nMeer = requestParameters.nMeer;
        const pwv = requestParameters.pwv;
        const el = requestParameters.el;
        const spectralAveragingFactor = requestParameters.spectralAveragingFactor;
        const spectralResolutionsHz = requestParameters.spectralResolutionsHz;
        const totalBandwidthsHz = requestParameters.totalBandwidthsHz;
        const sensitivitiesJy = requestParameters.sensitivitiesJy;
        const integrationTimeS = requestParameters.integrationTimeS;
        const etaSystem = requestParameters.etaSystem;
        const etaPointing = requestParameters.etaPointing;
        const etaCoherence = requestParameters.etaCoherence;
        const etaDigitisation = requestParameters.etaDigitisation;
        const etaCorrelation = requestParameters.etaCorrelation;
        const etaBandpass = requestParameters.etaBandpass;
        const tSysSka = requestParameters.tSysSka;
        const tRxSka = requestParameters.tRxSka;
        const tSplSka = requestParameters.tSplSka;
        const tSysMeer = requestParameters.tSysMeer;
        const tRxMeer = requestParameters.tRxMeer;
        const tSplMeer = requestParameters.tSplMeer;
        const tSkySka = requestParameters.tSkySka;
        const tGalSka = requestParameters.tGalSka;
        const tGalMeer = requestParameters.tGalMeer;
        const alpha = requestParameters.alpha;
        const etaMeer = requestParameters.etaMeer;
        const etaSka = requestParameters.etaSka;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (rxBand !== undefined && rxBand !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>rxBand, 'rx_band');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (nSka !== undefined && nSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nSka, 'n_ska');
        }
        if (nMeer !== undefined && nMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>nMeer, 'n_meer');
        }
        if (freqCentresHz) {
            freqCentresHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'freq_centres_hz');
            })
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (pwv !== undefined && pwv !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pwv, 'pwv');
        }
        if (el !== undefined && el !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>el, 'el');
        }
        if (spectralAveragingFactor !== undefined && spectralAveragingFactor !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>spectralAveragingFactor, 'spectral_averaging_factor');
        }
        if (spectralResolutionsHz) {
            spectralResolutionsHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'spectral_resolutions_hz');
            })
        }
        if (totalBandwidthsHz) {
            totalBandwidthsHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'total_bandwidths_hz');
            })
        }
        if (sensitivitiesJy) {
            sensitivitiesJy.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'sensitivities_jy');
            })
        }
        if (integrationTimeS !== undefined && integrationTimeS !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>integrationTimeS, 'integration_time_s');
        }
        if (etaSystem !== undefined && etaSystem !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaSystem, 'eta_system');
        }
        if (etaPointing !== undefined && etaPointing !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaPointing, 'eta_pointing');
        }
        if (etaCoherence !== undefined && etaCoherence !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaCoherence, 'eta_coherence');
        }
        if (etaDigitisation !== undefined && etaDigitisation !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaDigitisation, 'eta_digitisation');
        }
        if (etaCorrelation !== undefined && etaCorrelation !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaCorrelation, 'eta_correlation');
        }
        if (etaBandpass !== undefined && etaBandpass !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaBandpass, 'eta_bandpass');
        }
        if (tSysSka !== undefined && tSysSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSysSka, 't_sys_ska');
        }
        if (tRxSka !== undefined && tRxSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tRxSka, 't_rx_ska');
        }
        if (tSplSka !== undefined && tSplSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSplSka, 't_spl_ska');
        }
        if (tSysMeer !== undefined && tSysMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSysMeer, 't_sys_meer');
        }
        if (tRxMeer !== undefined && tRxMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tRxMeer, 't_rx_meer');
        }
        if (tSplMeer !== undefined && tSplMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSplMeer, 't_spl_meer');
        }
        if (tSkySka !== undefined && tSkySka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tSkySka, 't_sky_ska');
        }
        if (tGalSka !== undefined && tGalSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tGalSka, 't_gal_ska');
        }
        if (tGalMeer !== undefined && tGalMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>tGalMeer, 't_gal_meer');
        }
        if (alpha !== undefined && alpha !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>alpha, 'alpha');
        }
        if (etaMeer !== undefined && etaMeer !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaMeer, 'eta_meer');
        }
        if (etaSka !== undefined && etaSka !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>etaSka, 'eta_ska');
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/zoom/calculate`;
        return this.httpClient.request<Array<MidSingleZoomSensitivityResponse>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * Retrieve the parameters related to weighting (e.g. beam-size and relative sensitivity). As zoom mode currently only displays the spectral sensitivity/integration time, only the spectral (line) parameters are retrieved. 
     * @param requestParameters
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public skaOstSenscalcMidApiZoomWeighting(requestParameters: SkaOstSenscalcMidApiZoomWeightingRequestParams, observe?: 'body', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<Array<MidSingleWeightingZoomResult>>;
    public skaOstSenscalcMidApiZoomWeighting(requestParameters: SkaOstSenscalcMidApiZoomWeightingRequestParams, observe?: 'response', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpResponse<Array<MidSingleWeightingZoomResult>>>;
    public skaOstSenscalcMidApiZoomWeighting(requestParameters: SkaOstSenscalcMidApiZoomWeightingRequestParams, observe?: 'events', reportProgress?: boolean, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<HttpEvent<Array<MidSingleWeightingZoomResult>>>;
    public skaOstSenscalcMidApiZoomWeighting(requestParameters: SkaOstSenscalcMidApiZoomWeightingRequestParams, observe: any = 'body', reportProgress: boolean = false, options?: {httpHeaderAccept?: 'application/json', context?: HttpContext}): Observable<any> {
        const freqCentresHz = requestParameters.freqCentresHz;
        if (freqCentresHz === null || freqCentresHz === undefined) {
            throw new Error('Required parameter freqCentresHz was null or undefined when calling skaOstSenscalcMidApiZoomWeighting.');
        }
        const pointingCentre = requestParameters.pointingCentre;
        if (pointingCentre === null || pointingCentre === undefined) {
            throw new Error('Required parameter pointingCentre was null or undefined when calling skaOstSenscalcMidApiZoomWeighting.');
        }
        const weightingMode = requestParameters.weightingMode;
        if (weightingMode === null || weightingMode === undefined) {
            throw new Error('Required parameter weightingMode was null or undefined when calling skaOstSenscalcMidApiZoomWeighting.');
        }
        const robustness = requestParameters.robustness;
        const subarrayConfiguration = requestParameters.subarrayConfiguration;
        const taper = requestParameters.taper;

        let localVarQueryParameters = new HttpParams({encoder: this.encoder});
        if (freqCentresHz) {
            freqCentresHz.forEach((element) => {
                localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
                  <any>element, 'freq_centres_hz');
            })
        }
        if (pointingCentre !== undefined && pointingCentre !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>pointingCentre, 'pointing_centre');
        }
        if (weightingMode !== undefined && weightingMode !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>weightingMode, 'weighting_mode');
        }
        if (robustness !== undefined && robustness !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>robustness, 'robustness');
        }
        if (subarrayConfiguration !== undefined && subarrayConfiguration !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>subarrayConfiguration, 'subarray_configuration');
        }
        if (taper !== undefined && taper !== null) {
          localVarQueryParameters = this.addToHttpParams(localVarQueryParameters,
            <any>taper, 'taper');
        }

        let localVarHeaders = this.defaultHeaders;

        let localVarHttpHeaderAcceptSelected: string | undefined = options && options.httpHeaderAccept;
        if (localVarHttpHeaderAcceptSelected === undefined) {
            // to determine the Accept header
            const httpHeaderAccepts: string[] = [
                'application/json'
            ];
            localVarHttpHeaderAcceptSelected = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        }
        if (localVarHttpHeaderAcceptSelected !== undefined) {
            localVarHeaders = localVarHeaders.set('Accept', localVarHttpHeaderAcceptSelected);
        }

        let localVarHttpContext: HttpContext | undefined = options && options.context;
        if (localVarHttpContext === undefined) {
            localVarHttpContext = new HttpContext();
        }


        let responseType_: 'text' | 'json' | 'blob' = 'json';
        if (localVarHttpHeaderAcceptSelected) {
            if (localVarHttpHeaderAcceptSelected.startsWith('text')) {
                responseType_ = 'text';
            } else if (this.configuration.isJsonMime(localVarHttpHeaderAcceptSelected)) {
                responseType_ = 'json';
            } else {
                responseType_ = 'blob';
            }
        }

        let localVarPath = `/zoom/weighting`;
        return this.httpClient.request<Array<MidSingleWeightingZoomResult>>('get', `${this.configuration.basePath}${localVarPath}`,
            {
                context: localVarHttpContext,
                params: localVarQueryParameters,
                responseType: <any>responseType_,
                withCredentials: this.configuration.withCredentials,
                headers: localVarHeaders,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
